package cours01;

public class Colorier {

	public static void main(String[] args) {

		String tabPays[] = { "France", "Allemagne", "Suisse", "Italie", "Autriche", "Espagne", "Portugal", "Luxembourg",
				"Belgique" };
		String tabFront[][] = { { "France", "Allemagne" }, { "France", "Suisse" }, { "France", "Italie" },
				{ "France", "Espagne" }, { "France", "Luxembourg" }, { "France", "Belgique" },
				{ "Allemagne", "Suisse" }, { "Allemagne", "Autriche" }, { "Allemagne", "Luxembourg" },
				{ "Allemagne", "Belgique" }, { "Suisse", "Italie" }, { "Suisse", "Autriche" },
				{ "Allemagne", "Autriche" }, { "Italie", "Autriche" }, { "Espagne", "Portugal" },
				{ "Luxembourg", "Belgique" }, };
		String tabCoul[] = { "rouge", "vert", "bleu", "jaune", "violet", "noir" };

		int tabFrontI[][] = new int[tabFront.length][2];
		for (int i = 0; i < tabFront.length; i++) {
			tabFrontI[i][0] = pays(tabPays, tabFront[i][0]);
			tabFrontI[i][1] = pays(tabPays, tabFront[i][1]);
		}

		// n est la taille du problème
		int n = tabPays.length;
		int C = 4; // nombre de couleurs utilisé

		// représentation d'une combinaison
		int[] comb = new int[n];
		for (int i = 0; i < n; i++)
			comb[i] = 0;

		// recherche de l'ensemble des combinaisons
		boolean fin, color;
		do {

			fin = suivantPartitionP(comb, C);
			color = colorer(tabFrontI, comb);

		} while ((fin == false) && (color == false));

		// affichage du résultat 
		if (fin == true) {
			System.out.println("Pas assez de couleurs");
		} else {
			for (int i = 0; i < tabPays.length; i++) {
				System.out.println(tabPays[i] + " " + tabCoul[comb[i]]);
			}
		}

	}

	public static boolean colorer(int[][] tabFrontI, int[] comb) {

		for (int i = 0; i < tabFrontI.length; i++) {
			if (comb[tabFrontI[i][0]] == comb[tabFrontI[i][1]])
				return false;
		}
		return true;
	}

	// numéro du pays
	public static int pays(String[] tabPays, String nom) {
		int i;
		for (i = 0; i < tabPays.length; i++) {
			if (tabPays[i].equals(nom))
				break;
		}
		if (i == tabPays.length) {
			System.out.println("Pays inconnu : " + nom);
			System.exit(1);
		}
		return i;
	}

	// partition suivante
	public static boolean suivantPartitionP(int[] comb, int P) {
		int i = 0;
		do {
			if (comb[i] == P - 1) {
				comb[i] = 0;
				i++;
			} else {
				comb[i]++;
				break;
			}
		} while (i < comb.length);

		// dernière combinaison tout à vrai
		if (i == comb.length)
			return true;

		return false;
	}
}